/*
 * $Author: alliance $
 * $Id: bfl103.h,v 1.1.1.1 1998/10/21 16:32:37 alliance Exp $
 * $Date: 1998/10/21 16:32:37 $
 */
/*
 * $Log: bfl103.h,v $
 * Revision 1.1.1.1  1998/10/21 16:32:37  alliance
 * fpmap import
 *
 */

#ifndef bfl103_h
#define bfl103_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

#include <stdlib.h>

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
# ifdef __STDC__
#  define __P(args)  args
# else
#  define __P(args)  ()
# endif
#endif

#ifndef NULL
# define NULL	((void*) 0)
#endif

/*----------------------------------------------------------------------*/
/*                            Bfl List Macros                           */
/*----------------------------------------------------------------------*/

#define bfllistempty(list)		((list)->length == 0)
#define bfllistsize(list)		((list)->length)
#define bfllistbegin(list)		((list)->node->next)
#define bfllistend(list)		((list)->node)
#define bfllistrbegin(list)		bfllistend(list)
#define bfllistrend(list)		bfllistbegin(list)
#define bfllistnext(node)		((node)->next)
#define bfllistprev(node)		((node)->prev)
#define bfllistdata(node)		((node)->data)
#define bfllistfront(list)		bfllistdata(bfllistbegin(list))
#define bfllistback(list)		bfllistdata(bfllistprev(bfllistend(list)))
#define bfllistpushfront(list , data)	bfllistinsert(list, bfllistbegin(list), (data))
#define bfllistpushback(list, data)	bfllistinsert(list, bfllistend(list), (data))
#define bfllistpopfront(list)		bfllisterase(list, bfllistbegin(list))
#define bfllistpopback(list)		bfllisterase(list, bfllistprev(bfllistend(list)))

/*----------------------------------------------------------------------*/
/*                            Bfl Map Macros                            */
/*----------------------------------------------------------------------*/

#define bflmapleft(node)		((node)->left)
#define bflmapright(node)		((node)->right)
#define bflmapparent(node)		((node)->parent)
#define bflcolor(node)		((node)->color)
#define bflmapkey(node)			((node)->key)
#define bflmapdata(node)		((node)->data)

#define bflmaproot(map)			(bflmapparent((map)->header))
#define bflmapleftmost(map)		(bflmapleft((map)->header))
#define bflmaprightmost(map)		(bflmapright((map)->header))
#define bflmapsize(map)			((map)->size)
#define bflmapempty(map)		((map)->size == 0)
#define bflmapcompar(map)		((map)->compar)

#define bflmapbegin(map)		bflmapleft((map)->header)
#define bflmapend(map)			((map)->header)
#define bflmaprbegin(map)		bflmapright((map)->header)
#define bflmaprend(map)			((map)->header)

#define bflmapfront(map)		bflmapbegin( map )
#define bflmapback(map)			bflmaprbegin( map )

#define bflmapremove(map , key)		bflmaperase(map , bflmapfind(map , key))

/*----------------------------------------------------------------------*/
/*                            Bfl Tree Macros                           */
/*----------------------------------------------------------------------*/

#define bfltreeleft(node)		((node)->left)
#define bfltreeright(node)		((node)->right)
#define bfltreeparent(node)		((node)->parent)
#define bfltreecolor(node)		((node)->color)
#define bfltreedata(node)		((node)->data)

#define bfltreeroot(tree)		bfltreeparent((tree)->header)
#define bfltreeleftmost(tree)		bfltreeleft((tree)->header)
#define bfltreerightmost(tree)		bfltreeright((tree)->header)
#define bfltreesize(tree)		((tree)->size)
#define bfltreeempty(tree)		((tree)->size == 0)
#define bfltreecompare(tree)		((tree)->compare)

#define bfltreebegin(tree)		bfltreeleftmost(tree)
#define bfltreeend(tree)		((tree)->header)
#define bfltreerbegin(tree)		bfltreeend(tree)
#define bfltreerend(tree)		bfltreebegin(tree)

#define bfltreeremove(tree, data)	bfltreeerase(tree, bfltreefind(tree, data))

/*----------------------------------------------------------------------*/
/*                           Bfl Vector Macros                          */
/*----------------------------------------------------------------------*/

#define bflvectorempty(vector)		((vector)->start == (vector)->finish)
#define bflvectorsize(vector)		((vector)->finish - (vector)->start)
#define bflvectorbegin(vector)		((vector)->start)
#define bflvectorend(vector)		((vector)->finish)
#define bflvectorrbegin(vector)		((vector)->finish - 1)
#define bflvectorrend(vector)		((vector)->start - 1)
#define bflvectornext(node)		((node) + 1)
#define bflvectorprev(node)		((node) - 1)
#define bflvectordata(node)		(*(node))

#define bflvectorfront(vector)		bflvectorbegin(vector)
#define bflvectorback(vector)		bflvectorend(vector)

#define bflvectorpushfront(vector ,  data)	bflvectorinsert(vector , bflvectorfront(vector), data)
#define bflvectorpushback(vector ,  data)	bflvectorinsert(vector , bflvectorback(vector), data)
#define bflvectorpopfront(vector)		bflvectorerase(vector , bflvectorfront(vector))
#define bflvectorpopback(vector) 		bflvectorerase(vector , bflvectorback(vector))
#define bflvectorclean(vector)		((vector)->finish = (vector)->start)
#define bflvectornth(vector , n)		(*((vector)->start + n))

/*----------------------------------------------------------------------*/
/*                               Bfl Swap                               */
/*----------------------------------------------------------------------*/
	
#define bflswap(a, b)			(int)(a) ^= (int)(b); \
					(int)(b) ^= (int)(a); \
					(int)(a) ^= (int)(b)

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/* This is not a typedef so `const bflptr_t' does the right thing.  */
#ifdef __STDC__
# define bflptr_t	void *
#else
# define bflptr_t	char *
#endif

typedef unsigned int	 bflsize_t;

typedef int (*bflcompar_fn) __P((const bflptr_t, const bflptr_t));

/*----------------------------------------------------------------------*/
/*                           Bfl Position Type                          */
/*----------------------------------------------------------------------*/

typedef struct bflpos {
	double		 x;
	double		 y;
} bflpos_t;

/*----------------------------------------------------------------------*/
/*                           Bfl Memory Types                           */
/*----------------------------------------------------------------------*/

typedef struct bflmembuf {
	struct bflmembuf	*next;
	bflptr_t		 buffer;
} bflmembuf_t;

typedef struct bflmem {
	bflsize_t		 size;
	struct bflmembuf	*buffer_list;
	bflptr_t		 free_list;
	bflptr_t		 next_avail;
	bflptr_t		 last;
} bflmem_t;

/*----------------------------------------------------------------------*/
/*                            Bfl List Types                            */
/*----------------------------------------------------------------------*/

typedef struct bfllistnode {
	struct bfllistnode	*prev;
	struct bfllistnode	*next;
	bflptr_t		 data;
} bfllistnode_t;

typedef struct bfllist {
	bfllistnode_t		*node;
	bflsize_t		 length;
} bfllist_t;

/*----------------------------------------------------------------------*/
/*                             Bfl Map Types                            */
/*----------------------------------------------------------------------*/

typedef	enum {
	bflblack,
	bflred
} bflcolor_t;

typedef struct bflmapnode {
	struct bflmapnode	*left;	/* left child			*/
	struct bflmapnode	*right;	/* right child			*/
	struct bflmapnode	*parent;/* parent			*/
	bflcolor_t		 color;	/* node color (black, red)	*/
	bflptr_t		 key;	/* key of this node		*/
	bflptr_t		 data;	/* data stored in node		*/
} bflmapnode_t;

typedef struct bflmap {
	bflmapnode_t		*header;
	bflsize_t		 size;
	bflcompar_fn		 compar;
	int			 duplicate;
} bflmap_t;

/*----------------------------------------------------------------------*/
/*                            Bfl Tree Types                            */
/*----------------------------------------------------------------------*/

typedef struct bfltreenode {
	struct bfltreenode	*left;		/* left child		*/
	struct bfltreenode	*right;		/* right child		*/
	struct bfltreenode	*parent;	/* parent		*/
	bflcolor_t		 color;		/* node color 		*/
	bflptr_t		 data;		/* data stored in node	*/
} bfltreenode_t;

typedef struct bfltree {
	bfltreenode_t		*header;
	bflsize_t		 size;
	bflcompar_fn		 compar;
	int			 duplicate;
} bfltree_t;

/*----------------------------------------------------------------------*/
/*                           Bfl Vector Types                           */
/*----------------------------------------------------------------------*/

typedef struct bflvector {
	bflptr_t		*start;
	bflptr_t		*finish;
	bflptr_t		*end_of_storage;
} bflvector_t;

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

extern	char	*__progname;

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

extern void
bflenv __P((char *progname));

/*----------------------------------------------------------------------*/
/*                          Bfl Error Functions                         */
/*----------------------------------------------------------------------*/

extern void
bflsyserror __P((int status, const char *fmt, ...));

extern void
bflerror __P((int status, const char *fmt, ...));

extern void
bflsyswarning __P((const char *fmt, ...));

extern void
bflwarning __P((const char *fmt, ...));

/*----------------------------------------------------------------------*/
/*                          Bfl Memory Function                         */
/*----------------------------------------------------------------------*/

extern bflmem_t *
bflnewmem __P((bflsize_t size));

extern void
bflfreemem __P((bflmem_t *mem));

extern bflptr_t	
bflnew __P((bflmem_t *mem));

extern void
bflfree __P((bflmem_t *mem, bflptr_t ptr));

extern bflptr_t
bflcalloc(bflsize_t nmemb, bflsize_t size);

extern bflptr_t
bflalloc(bflsize_t size);

extern bflptr_t
bflrealloc(bflptr_t ptr, bflsize_t size);

/*----------------------------------------------------------------------*/
/*                         Bfl String Functions                         */
/*----------------------------------------------------------------------*/

extern char *
bflstrdup __P((const char *s));

extern char *
bflstrcat __P((char *dest, const char *src));

extern char *
bflstrncat __P((char *dest, const char *src, bflsize_t n));

extern int
bflstrmatch __P((char *pattern, char *string));

/*----------------------------------------------------------------------*/
/*                         Bfl Compare Functions                        */
/*----------------------------------------------------------------------*/

extern int
bflptrcmp __P((const bflptr_t x, const bflptr_t y));

extern int
bflnumcmp __P((const bflptr_t x, const bflptr_t y));

extern int
bflstrcmp __P((const bflptr_t x, const bflptr_t y));

/*----------------------------------------------------------------------*/
/*                          Bfl Less Functions                          */
/*----------------------------------------------------------------------*/

extern int
bflptrless __P((const bflptr_t x, const bflptr_t y));

extern int
bflnumless __P((const bflptr_t x, const bflptr_t y));

extern int
bflstrless __P((const bflptr_t x, const bflptr_t y));

/*----------------------------------------------------------------------*/
/*                          Bfl List Functions                          */
/*----------------------------------------------------------------------*/

extern bfllist_t *
bfllistnew __P((void));

extern void
bfllistfree __P((bfllist_t *list));

extern bfllist_t *
bfllistcopy __P((bfllist_t *list));

extern void
bfllistclean __P((bfllist_t *list));

extern bfllistnode_t *
bfllistinsert __P((bfllist_t *list, bfllistnode_t *pos, bflptr_t data));

extern void
bfllisterase __P((bfllist_t *list, bfllistnode_t *pos));

extern bfllistnode_t *
bfllistfind __P((bfllist_t *list, bflcompar_fn compar, bflptr_t data));

extern bfllistnode_t *
bfllistnth __P((bfllist_t *list, bflsize_t index));

extern void
bfllistremove __P((bfllist_t *list, bflcompar_fn compar, bflptr_t dataue));

extern void
bfllistreverse __P((bfllist_t *list));

extern void
bfllistmerge __P((bfllist_t *list1, bfllist_t *list2, bflcompar_fn compar));

extern void
bfllistsort __P((bfllist_t *list, bflcompar_fn compar));

/*----------------------------------------------------------------------*/
/*                           Bfl Map Functions                          */
/*----------------------------------------------------------------------*/

extern bflmap_t	*
bflmapnew __P((bflcompar_fn compar, int dup));

extern void
bflmapfree __P((bflmap_t *map));

extern bflmap_t *
bflmapcopy __P((bflmap_t *map));

extern void
bflmapclean __P((bflmap_t *map));

extern bflmapnode_t *
bflmapinsert __P((bflmap_t *map, bflptr_t key, bflptr_t data));

extern void
bflmaperase __P((bflmap_t *map, bflmapnode_t *node));

extern bflmapnode_t *
bflmapfind __P((bflmap_t *map, bflptr_t key));

extern bflmapnode_t *
bflmapmin __P((bflmapnode_t *node));

extern bflmapnode_t *
bflmapmax __P((bflmapnode_t *node));

extern bflmapnode_t *
bflmapnext __P((bflmapnode_t *node));

extern bflmapnode_t *
bflmapprev __P((bflmapnode_t *node));

/*----------------------------------------------------------------------*/
/*                          Bfl Tree Functions                          */
/*----------------------------------------------------------------------*/

extern bfltree_t *
bfltreenew __P((bflcompar_fn compar, int dup));

extern void
bfltreefree __P((bfltree_t *tree));

extern bfltree_t *
bfltreecopy __P((bfltree_t *tree));

extern void
bfltreeclean	__P((bfltree_t *tree));

extern bfltreenode_t *
bfltreeinsert __P((bfltree_t *tree, bflptr_t data));

extern void
bfltreeerase __P((bfltree_t *tree, bfltreenode_t *node));

extern bfltreenode_t *
bfltreefind __P((bfltree_t *tree, bflptr_t data));

extern bfltreenode_t *
bfltreemin __P((bfltreenode_t *x));

extern bfltreenode_t *
bfltreemax __P((bfltreenode_t *x));

extern bfltreenode_t *
bfltreenext __P((bfltreenode_t *node));

extern bfltreenode_t *
bfltreeprev __P((bfltreenode_t *node));

/*----------------------------------------------------------------------*/
/*                         Bfl Vector Functions                         */
/*----------------------------------------------------------------------*/

extern bflvector_t *
bflvectornew __P((void));

extern void
bflvectorfree __P((bflvector_t *vector));

extern bflvector_t *
bflvectorcopy __P((bflvector_t *vector));

extern bflptr_t *
bflvectorinsert __P((bflvector_t *vector, bflptr_t *pos, bflptr_t data));

extern void	
bflvectorerase __P((bflvector_t *vector, bflptr_t *pos));

extern bflptr_t	*
bflvectorfind __P((bflvector_t *vector, bflcompar_fn compar, bflptr_t data));

extern void	
bflvectorremove __P((bflvector_t *vector, bflcompar_fn compar, bflptr_t data));

extern void	
bflvectorsort __P((bflvector_t *vector, bflcompar_fn compar));

extern bflptr_t	*
bflvectorsearch __P((bflvector_t *vector, bflcompar_fn compar, bflptr_t data));

/*----------------------------------------------------------------------*/
/*                          Bfl Math Functions                          */
/*----------------------------------------------------------------------*/

extern long
bfllog2 __P((long num ));

extern long
bflround __P((long num ));

/*----------------------------------------------------------------------*/
/*                           Bfl Sort Function                          */
/*----------------------------------------------------------------------*/

extern void
bflsort __P((bflptr_t base, bflsize_t n, bflsize_t size, bflcompar_fn compar));

/*----------------------------------------------------------------------*/
/*                        Bfl Position Functions                        */
/*----------------------------------------------------------------------*/

extern bflpos_t
bflposadd __P((bflpos_t x, bflpos_t y));

extern bflpos_t
bflpossub __P((bflpos_t x, bflpos_t y));

extern double
bflposnorm __P((bflpos_t x));

extern bflpos_t
bflposunit __P((bflpos_t x));

extern double
bflposdot __P((bflpos_t x, bflpos_t y));

#endif /* bfl103_h */
