/*
 * $Author: alliance $
 * $Id: testvector.c,v 1.1.1.1 1998/10/21 16:32:38 alliance Exp $
 * $Date: 1998/10/21 16:32:38 $
 */
/*
 * $Log: testvector.c,v $
 * Revision 1.1.1.1  1998/10/21 16:32:38  alliance
 * fpmap import
 *
 */

# include <assert.h>
# include <stdio.h>
# include BFL_H

void
printvector( vec )
    bflvector_t *vec;
{
    bflptr_t *first = bflvectorbegin( vec );
    bflptr_t *last  = bflvectorend( vec );
    
    printf( "#vector( %p ) : [ ", vec );
    while ( first != last ) {
	printf( "%d ", (int)bflvectordata( first ) );
        first = bflvectornext( first );
    }
    puts( "]" );
}

void
test_sort()
{
	bflvector_t *vec = bflvectornew();
	
	printf("\ntest_sort\n");

	bflvectorpushback(vec, (bflptr_t)9);
	bflvectorpushback(vec, (bflptr_t)0);
	bflvectorpushback(vec, (bflptr_t)8);
	bflvectorpushback(vec, (bflptr_t)1);
	bflvectorpushback(vec, (bflptr_t)7);
	bflvectorpushback(vec, (bflptr_t)2);
	bflvectorpushback(vec, (bflptr_t)6);
	bflvectorpushback(vec, (bflptr_t)3);
	bflvectorpushback(vec, (bflptr_t)5);
	bflvectorpushback(vec, (bflptr_t)4);

	printvector(vec);
	bflvectorsort(vec, bflnumcmp);
	printvector(vec);
	bflvectorfree(vec);
}

int main()
{
    int i;
    bflptr_t *first;
    bflptr_t *last;
    bflvector_t *vec = bflvectornew();
    
    assert( bflvectorempty( vec ) == 1 );
    assert( bflvectorsize( vec ) == 0 );
    
    for ( i = 0; i < 10; i++ )
	bflvectorpushback( vec, (void*)i );
    
    printvector( vec );
    assert( bflvectorempty( vec ) == 0   );
    assert( bflvectorsize( vec )  == 10 );
    
    i = 0;
    first = bflvectorbegin( vec );
    last  = bflvectorend( vec );
    while ( first != last ) {
        assert( i == (int)bflvectordata( first ) );
        first = bflvectornext( first );
	i += 1;
    }
    
    i = 9;
    first = bflvectorrbegin( vec );
    last  = bflvectorrend( vec );
    while ( first != last ) {
        assert( i == (int)bflvectordata( first ) );
        first = bflvectorprev( first );
	i -= 1;
    }
    
    bflvectorpopfront( vec );
    printvector( vec );
    
    assert( bflvectorempty( vec ) == 0   );
    assert( bflvectorsize( vec )  == 9 );
    
    i = 1;
    first = bflvectorbegin( vec );
    last  = bflvectorend( vec );
    while ( first != last ) {
        assert( i == (int)bflvectordata( first ) );
        first = bflvectornext( first );
	i += 1;
    }
    
    bflvectorpopback( vec );
    printvector( vec );

    assert( bflvectorempty( vec ) == 0   );
    assert( bflvectorsize( vec )  == 8 );
    
    i = 1;
    first = bflvectorbegin( vec );
    last  = bflvectorend( vec );
    while ( first != last ) {
        assert( i == (int)bflvectordata( first ) );
        first = bflvectornext( first );
	i += 1;
    }
    
    assert( (int)bflvectornth( vec, 2 ) == 3 );

    assert( bflvectorbegin( vec ) + 2 == bflvectorfind( vec, bflptrcmp, (void*)3 ) );

    bflvectorremove( vec, bflptrcmp, (void*)1 );
    printvector( vec );

    assert( bflvectorempty( vec ) == 0   );
    assert( bflvectorsize( vec )  == 7 );
    
    i = 2;
    first = bflvectorbegin( vec );
    last  = bflvectorend( vec );
    while ( first != last ) {
        assert( i == (int)bflvectordata( first ) );
        first = bflvectornext( first );
	i += 1;
    }
    
    bflvectorclean( vec );
    printvector( vec );

    assert( bflvectorempty( vec ) == 1 );
    assert( bflvectorsize( vec )  == 0 );
    
    bflvectorfree( vec );
    test_sort();
    puts("functional test good for 'tvector'");
    return 0;
}

