/*
 * $Author: alliance $
 * $Id: buttest.c,v 1.1.1.1 1998/10/21 16:32:39 alliance Exp $
 * $Date: 1998/10/21 16:32:39 $
 */
/*
 * $Log: buttest.c,v $
 * Revision 1.1.1.1  1998/10/21 16:32:39  alliance
 * fpmap import
 *
 */

#include MUT_H
#include BFL_H
#include AUT_H
#include ABL_H
#include BDD_H
#include BEH_H
#include BHL_H
#include BVL_H
#include BUT_H

static void 
usage(void)
{
    puts("usage: testbut [switches] <file1 file2 ...>");
    puts("Most frequently used switches:");
    puts("  -u               devectorise tous les beaux.");
    puts("  -h               display this help screen.");
    puts("  -s               sweep tous les beaux dont le support est < 2.");
    puts("For more complete information, please read the fpplace man page.");
    exit(1);
}

int
main(int argc, char ** argv)
{
	befig_list *befig;
	int         opt_unvector = 0;
	int         opt_sweep    = 0;
	int opt;

	mbkenv();
	bflenv(argv[0]);
	autenv();
	ablenv();

	while ((opt = getopt(argc, argv, "us")) != EOF) {
		switch (opt) {
		case 'u':
			opt_unvector = 1;
			break;
		case 's':
			opt_sweep = 1;
			break;
		default:
			usage();
		}
	}
	
	if (optind == argc)
		usage();
	
	while (optind < argc) {
		printf(" * Loading vhdl file `%s.vbe' ...\n", argv[optind]);
		befig = vhdlloadbefig(NULL, argv[optind++], 0);
		but_postfix_name(befig, "u");

		but_compil(befig);

		if (opt_unvector == 1)
			but_unvector(befig, BUT_BEAUX);
		
		but_makebdd(befig, 0, NULL);
		
		if (opt_sweep == 1)
			but_sweep(befig, BUT_SWEEP_BDD);
		
		vhdlsavebefig(befig, 0);
		befig = beh_delbefig(befig, befig, 'Y');
	}


	return 0;
}

